<template>
  <ion-page>
    <ion-tabs>
      <ion-router-outlet></ion-router-outlet>
      <ion-tab-bar
        slot="bottom"
        color="secondary"
        :dir="languageIsEnglish ? 'ltr' : 'rtl'"
      >
        <ion-tab-button tab="message" href="/message">
          <ion-icon icon="/Images/tabs/message.svg" />
          <ion-label>{{ t('tabs.message.title') }}</ion-label>
        </ion-tab-button>

        <ion-tab-button tab="contacts" href="/contacts">
          <ion-icon icon="/Images/tabs/contacts.svg" />
          <ion-label>{{ t('tabs.contacts.title') }}</ion-label>
        </ion-tab-button>

        <ion-tab-button tab="callpad" href="/callpad">
          <ion-icon icon="/Images/tabs/call-pad.svg" />
          <ion-label>{{ t('tabs.callpad.keypad') }}</ion-label>
        </ion-tab-button>

        <ion-tab-button tab="history" href="/history">
          <ion-icon icon="/Images/tabs/history.svg" />
          <ion-label>{{ t('tabs.callHistory.history') }}</ion-label>
        </ion-tab-button>
        <ion-tab-button tab="profile" href="/profile">
          <ion-icon icon="/Images/tabs/profile.svg" />
          <ion-label>{{ t('tabs.profile.title') }}</ion-label>
        </ion-tab-button>
      </ion-tab-bar>
    </ion-tabs>
    <ion-modal :is-open="showCallingModal">
      <CallingModal></CallingModal>
    </ion-modal>
    <ion-modal :is-open="showVideoCallModal">
      <VideoCallingModal></VideoCallingModal>
    </ion-modal>
    <audio preload="auto" webkit-playsinline playsinline loop ref="ringback">
      <source src="/audio/ringback.mp3" />
    </audio>
    <audio preload="auto" webkit-playsinline playsinline loop ref="holdAudio">
      <source src="/audio/hold.mp3" />
    </audio>
    <audio preload="auto" webkit-playsinline playsinline loop ref="ringtone">
      <source src="/audio/ringtone.mp3" />
    </audio>

    <NotificationModal></NotificationModal>
    <MicrophoneModal></MicrophoneModal>
  </ion-page>
</template>

<script setup>
import {
  IonPage,
  IonTabs,
  IonRouterOutlet,
  IonTabBar,
  IonTabButton,
  IonLabel,
  IonIcon,
  IonModal,
} from '@ionic/vue';
import { ref, onMounted, computed } from 'vue';
import CallingModal from '@/components/callpad/Calling.vue';
import VideoCallingModal from '@/components/callpad/VideoCalling.vue';
import { useContactsStore } from '@/store/contacts/contacts.js';
import { useCdrStore } from '@/store/callHistory/callHistory.js';
import { useUserStore } from '@/store/user/user.js';
import { useOverallChatsStore } from '@/store/chats/overall.js';
import { useI18n } from 'vue-i18n';
import { useRTMStore } from '@/store/rtm/rtm.js';
import NotificationModal from '@/components/Permission/NotificationModal.vue';
import MicrophoneModal from '@/components/Permission/MicrophoneModal.vue';
import { useCallStore } from '@/store/call/call.js';
import { useVideoCallStore } from '@/store/videoCall/videoCall.js';
import { version } from '@/../package.json';
import { getBowserName, getOsOfUser } from '@/helpers/parser.js';
const { t, locale } = useI18n();
import { userReseterStore } from '@/store/reset.js';
import { handelBrowserTabVisibilityChange } from '@/helpers/browserApis.js';
import { detectOsForNavigate } from '@/helpers/parser.js';

const callStore = useCallStore();
const userStore = useUserStore();
const contactsStore = useContactsStore();
const RTMStore = useRTMStore();
const cdrStore = useCdrStore();
const videoCallStore = useVideoCallStore();

const languageIsEnglish = computed(() => locale.value == 'en');

const ringback = ref();
const holdAudio = ref();
const ringtone = ref();
const showCallingModal = computed(() => {
  return callStore.getCallModalStatus.showModal;
});
const showVideoCallModal = computed(() => {
  return videoCallStore.showVideoCallModal;
});
onMounted(() => {
  handelBrowserTabVisibilityChange();
  detectOsForNavigate();
  console.log(
    `%cVersion: ${version}`,
    'color: #ffffff; background-color: #428cff; padding: 8px; border-radius: 4px;',
    '\nThis ui has implemented for mobile devices till now.\nDesign for desktop and tablet is under developing. \n',
  );
  const callStore = useCallStore();
  callStore.register();
  const overallStore = useOverallChatsStore();
  overallStore.getChatList();
  RTMStore.connect();
  contactsStore.getContactsList();
  cdrStore.getCallHistory();
  userStore.getCurrentUserProfile();
  callStore.setAudioTag(ringback.value, ringtone.value, holdAudio.value);

  import('@/registerServiceWorker.js')
    .then((module) => {
      const userStore = useUserStore();
      const browserName = getBowserName();
      const osName = getOsOfUser();
      module.registerHandler(
        userStore.userId,
        userStore.sessionToken,
        userStore.token,
        browserName,
        osName,
      );
    })
    .catch((e) => {});

  window.addEventListener('beforeunload', (event) => {
    const reseterStore = userReseterStore();
    reseterStore.setLengthForSaveInLocalStorage();
  });
});
</script>
<style scoped>
ion-tab-bar {
  height: 10vh;
  position: relative;
  z-index: 55;
}
ion-label {
  font-size: calc(14px - 1.2vmin);
}
ion-tab-button {
  background-color: transparent;
  color: #938d8d;
}
.tab-selected {
  color: var(--ion-color-primary);
  fill: var(--ion-color-primary);
}
.tab-selected ion-icon {
  fill: var(--ion-color-primary) !important;
  color: var(--ion-color-primary) !important;
}
</style>
